#include <iostream>
#include <fstream>
#include "Pokemon.h"

using namespace std;

//this method accepts a pointer to a Pokemon object,
//then calls the talk method on it.
void makeItTalk(Employee* p) {
    p->talk();
}

int main(int argc, char* argv[]) {
    cout << "You passed " << argc << " command-line parameters." << endl;
    cout << "Welcome to Employee Database";
    cout << " Here is all the employee information" << endl;

    // Check if a filename is provided as a command-line parameter
        if (argc != 2) {
            cerr << "Usage: " << argv[0] << "Please enter the program name followed by the file name." << endl;
            return 1; // Return an error code
        }
    
    ifstream ifs;
    ifs.open(argv[1], ios::in);
    
    if (!ifs.is_open()) {
            cerr << "Error opening file: " << argv[1] << endl;
            return 1; // Return an error code
        }

    
    string name, jobTitle, firstLine, hireYearString, idNumberString, ageString;
    int idNumber = 0, age = 0, hireYear; //local variables assigned for each part of the line
    

    getline(ifs, firstLine);
    int numberOfEmployees = stoi(firstLine); //turn the frist line into an integer
    Employee** employeeDatabase = new Employee*[numberOfEmployees]; //create a array with cells equal to number of lines

    //my first for-loop reads from the file
    for (int i=0; i<numberOfEmployees; i++) {
        getline(ifs, name, '|');
        getline(ifs, idNumberString, '|');
        getline(ifs, ageString, '|');
        getline(ifs, jobTitle, '|');
        getline(ifs, hireYearString);
        
        //now I need to convert the string numbers to integers
        hireYear = stoi(hireYearString);
        idNumber = stoi(idNumberString);
        age = stoi(ageString);
        
        employeeDatabase[i] = new Employee(name, idNumber, age, jobTitle, hireYear);
        
        
    }
    
    
    //NEW CODE
    string stringOfQueries;
    getline(ifs, stringOfQueries); //grab the string which is the line
    int numberOfQueries  = stoi(stringOfQueries); //change from string to int
    int totalComparisons = 0; // Variable to store the total number of comparisons
    
    
    
    
    for (int i=0; i<numberOfQueries; i++) {
        
        string queryString;
        getline(ifs, queryString);
        
        int queryID = stoi(queryString);
        int comparisons = 0; // Variable to count the number of comparisons for this query
        
        bool found = false;
        
        for (int j = 0; j < numberOfEmployees; j++) {
            
            comparisons++;
            
            if (employeeDatabase[j]-> getID() == queryID) {
                found = true;
                cout << "FOUND" << endl;
                employeeDatabase[j]->talk();
                cout << "at index " << j << " after "<< comparisons << " comparisons." << endl;
                break;  // Stop searching after finding the first match
            }
        }
        
        totalComparisons += comparisons; // Accumulate comparisons for all queries

            // If no match is found, print "NOT FOUND"
        if (!found) {
            cout << "NOT FOUND" << endl;
        }
        
        
    }
    
    // Print the average number of comparisons
    double averageComparisons = static_cast<double>(totalComparisons) / numberOfQueries;
    cout << "Done! Average amount of work per query: " << averageComparisons << " comparisons." << endl;


    return 0;
}

/*
 * multi
 * line
 * comment
 */
